#
# (c) https://github.com/MontiCore/monticore
#
# The license generally applicable for this project
# can be found under https://github.com/MontiCore/monticore.
#


stages:
- windows
- docker
- linux


masterJobLinux:
  stage: linux
  image: maven:3-jdk-8
  before_script:
  - apt update
  - apt --assume-yes install libxext6
  - apt --assume-yes install libxrender1
  - apt --assume-yes install libxtst6
  script: 
  - "JAWT_LIB=$(find / -name libjawt.so -print -quit)"
  - "echo JAWT_LIB: $JAWT_LIB"
  - "JAWT_FOLDER=$(dirname ${JAWT_LIB})"
  - "echo JAWT_FOLDER: $JAWT_FOLDER"
  - "export LD_LIBRARY_PATH=$LD_LIBRARY_PATH:${JAWT_FOLDER}"
  - mvn -Dorg.slf4j.simpleLogger.log.org.apache.maven.cli.transfer.Slf4jMavenTransferListener=warn -B  clean deploy --settings settings.xml
  - mvn package sonar:sonar -s settings.xml
  only:
  - master

  
masterJobWindows:
  stage: windows
  script: 
  - mvn -Dorg.slf4j.simpleLogger.log.org.apache.maven.cli.transfer.Slf4jMavenTransferListener=warn -B  clean install --settings settings.xml
  tags:
  - Windows10
  only:
    - master
  artifacts:
    paths:
      - install/rmi-model-server.jar

BranchJobLinux:
  stage: linux
  image: maven:3-jdk-8
  before_script:
  - apt update
  - apt --assume-yes install libxext6
  - apt --assume-yes install libxrender1
  - apt --assume-yes install libxtst6
  #- apt --assume-yes install realpath
  script: 
  - "JAWT_LIB=$(find / -name libjawt.so -print -quit)"
  - "echo JAWT_LIB: $JAWT_LIB"
  - "JAWT_FOLDER=$(dirname ${JAWT_LIB})"
  - "echo JAWT_FOLDER: $JAWT_FOLDER"
  - "export LD_LIBRARY_PATH=$LD_LIBRARY_PATH:${JAWT_FOLDER}"
  - mvn -Dorg.slf4j.simpleLogger.log.org.apache.maven.cli.transfer.Slf4jMavenTransferListener=warn -B  clean install --settings settings.xml
  except:
  - master

masterJobDocker:
  image: docker:dind
  stage: docker
  before_script:
    - docker login -u $CI_REGISTRY_USER -p $CI_REGISTRY_PASSWORD $CI_REGISTRY
  tags:
    - docker
  script:
    - cd docker
    - sh ./build.sh
    - docker tag rmi-server:latest $CI_REGISTRY_IMAGE:$CI_COMMIT_SHA
    - docker tag rmi-server:latest $CI_REGISTRY_IMAGE:latest
    - docker push $CI_REGISTRY_IMAGE:$CI_COMMIT_SHA
    - docker push $CI_REGISTRY_IMAGE:latest
  only:
    - master
